package
{
	import net.flashpunk.*;
	import net.flashpunk.graphics.*;
	import net.flashpunk.masks.*;
	import net.flashpunk.utils.*;
	
	import flash.display.*;
	import flash.geom.*;
	import flash.text.*;
	import flash.events.*;
	
	public class Disclaimer extends Preloader
	{
		[Embed(source="fonts/rooky_hand_normal.ttf", fontName='rookyhand', mimeType='application/x-font-truetype')]
		public static var fontSrc : Class;
		
		public var accepted:Boolean = false;
		
		public var sprite:Sprite = new Sprite();
		
		public function Disclaimer ()
		{
			super("MainMenu", false);
			
			var ss:StyleSheet = new StyleSheet();
			ss.parseCSS('.all { color: #000000; leading: 10px; } .x { font-family: "rookyhand"; color: #111111; }');

			var text: TextField = new MyTextField(5, 60, "", "left", 30);
			text.multiline = true;
			text.wordWrap = true;
			
			text.styleSheet = ss;
			text.htmlText = '<span class="all">I, <span class="x">the player</span>, do hereby agree to indemnify you, <span class="x">the game developer</span> against any injury or accident that may or may not occur to my <span class="x">eyes/ears/nose</span> due to the playing of <span class="x">this game</span>.</span>';
			text.embedFonts = true;
			text.width = 470;
			
			sprite.addChild(text);
			
			sprite.addChild(new MyTextField(240, 5, "DISCLAIMER", "center", 40, null, 0xFF0000));
			
			var button:Sprite = new Sprite;
			
			var agreeText:TextField = new MyTextField(0, 0, "I agree", "left", 40, "rookyhand", 0x772222);
			
			button.addChild(agreeText);
			
			button.graphics.beginFill(0xFFFFFF);
			button.graphics.drawRect(0, 0, agreeText.width, agreeText.height);
			button.graphics.endFill();
			
			button.x = 420 - button.width;
			button.y = 390;
			
			var line:Sprite = new Sprite;
			
			line.graphics.lineStyle(3, 0x772222);
			line.graphics.moveTo(button.width, button.height - 14);
			line.graphics.lineTo(0, button.height - 9);
			
			line.visible = false;
			
			button.addChild(line);
			
			button.buttonMode = true;
			button.mouseChildren = false;
			
			button.addEventListener(MouseEvent.ROLL_OVER, function (param: * = 0) : void { line.visible = true; });
			button.addEventListener(MouseEvent.ROLL_OUT, function (param: * = 0) : void { line.visible = false; });
			
			sprite.addChild(button);
			
			FP.engine.addChild(sprite);
			
			button.addEventListener(MouseEvent.CLICK, function (param: * = 0) : void {
				accepted = true;
				
				FP.engine.removeChild(sprite);
				
				FP.stage.focus = FP.stage;
			});
		}
		
		public override function update (): void
		{
			if (accepted) {
				super.update();
				return;
			}
		}
		
		public override function render (): void
		{
			if (accepted) {
				super.render();
				return;
			}
		}
	}
}
