package
{
	import net.flashpunk.*;
	import net.flashpunk.graphics.*;
	import net.flashpunk.masks.*;
	import net.flashpunk.utils.*;
	
	import flash.display.*;
	import flash.geom.*;
	
	public class Player extends Entity
	{
		public var dx: Number = 0;
		public var dy: Number = -1;
		
		public var vx: Number = 0;
		public var vy: Number = -1;
		
		public var frame: int = 0;
		public var lastFired: int = -100;
		
		public const FIRE_DELAY: int = 15;
		
		public function Player ()
		{
			x = 240;
			y = 240;
		}
		
		public override function update (): void
		{
			frame++;
			
			if (Input.mouseDown || Input.mousePressed) {
				if (frame - lastFired > FIRE_DELAY) {
					lastFired = frame;
					
					var b: Bullet = Bullet.create(this);
					
					FP.world.add(b);
				}
			}
			
			var DX: Number = FP.world.mouseX - x;
			var DY: Number = FP.world.mouseY - y;
			
			if (DX == 0 && DY == 0) { return; }
			
			var dz: Number = Math.sqrt(DX*DX + DY*DY);
			
			if (dz < 2) { return; }
			
			dx = DX;
			dy = DY;
			
			vx = dx * 0.1;
			vy = dy * 0.1;
			
			x += vx;
			y += vy;
			
			dx /= dz;
			dy /= dz;
		}
		
		public override function render (): void
		{
			const w: Number = 8;
			const h: Number = 10;
			Draw.line(x + dx * h, y + dy * h, x - dx * h - dy*w, y - dy * h + dx*w, 0xFFFFFF);
			Draw.line(x + dx * h, y + dy * h, x - dx * h + dy*w, y - dy * h - dx*w, 0xFFFFFF);
			Draw.line(x - dx * h + dy*w, y - dy * h - dx*w, x - dx * h - dy*w, y - dy * h + dx*w, 0xFFFFFF);
			Draw.line(x + dx * (h+1), y + dy * (h+1), x - dx * (h-1) - dy*w, y - dy * (h-1) + dx*w, 0xFFFFFF);
			Draw.line(x + dx * (h+1), y + dy * (h+1), x - dx * (h-1) + dy*w, y - dy * (h-1) - dx*w, 0xFFFFFF);
			Draw.line(x - dx * (h-1) + dy*w, y - dy * (h-1) - dx*w, x - dx * (h-1) - dy*w, y - dy * (h-1) + dx*w, 0xFFFFFF);
		}
	}
}
